// Uebung1 Betriebssysteme 2
// Matthias Jauernig, 2006
// Empfaenger-Programm

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/msg.h>

struct mymsg{
	long mtyp;
	short maction;
	char mtext[100];
} msg;

int main(void){
	int msqid, msqflag, rc, l, len, flag, scount;
	long msqtyp;
	char* fname = (char*)malloc(100*sizeof(char));
	FILE* fp;
	len = sizeof(msg.mtext) + sizeof(msg.maction);
	key_t msqkey;
	
	flag = 0; msqtyp = 0; // erste Nachricht der Queue erhalten und blockierend
	msqflag = IPC_CREAT | 0644; // nur Eigentuemer soll schreiben knnen, die anderen lesen
	msqkey = 251; // eindeutiger Key

	if((msqid = msgget(msqkey, msqflag)) < 0){
		perror("Fehler beim Erzeugen der Message Queue");
		return 1;
	}
	
	scount = 0;
	// Nachrichten aus Message Queue lesen bis keine Sender mehr vorhanden
	do{
		l = msgrcv(msqid, &msg, len, msqtyp, flag);
		sprintf(fname, "%ld.txt", msg.mtyp);
		switch(msg.maction){
		case 0: // Initial-Sendung
			scount++;
			printf("Sender %ld hat sich angemeldet, %d Sender nun vorhanden.\n", msg.mtyp, scount);
			break;
		case 1: // neue Nachricht gesendet
			printf("Neue Nachricht von Sender %ld empfangen.\n", msg.mtyp);
			fp = fopen(fname, "a"); // Datei zum Anhaengen oeffnen oder neu erstellen
			fwrite(&msg.mtext, sizeof(msg.mtext), 1, fp); // Nachrichtenzeile an Datei anhaengen
			fclose(fp);
			break;
		case 2: // Sender-Ende
			scount--;
			fp = fopen(fname, "r"); // Datei oeffnen, um ihren Inhalt zu lesen
			if(fp != NULL)
			{
				printf("Sender %ld hat sich beendet, noch %d Sender vorhanden.\n", msg.mtyp, scount);
				printf("Text von Sender %ld:\n", msg.mtyp);
				while(fread(msg.mtext, sizeof(msg.mtext), 1, fp) > 0){
					printf("%s", msg.mtext);
				}
				fclose(fp);
				unlink(fname);
			}
			break;
		}
	}while(scount > 0);
	
	// Message Queue beseitigen
	if((rc = msgctl(msqid, IPC_RMID, 0)) < 0){
		perror("Fehler beim Beseitigen der Message Queue.");
	}
	
	return 0;
}
