// Uebung1 Betriebssysteme 2
// Matthias Jauernig, 2006
// Sender-Programm

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/msg.h>

struct mymsg{
	long mtyp;
	short maction; // 0 = Init, 1 = Senden, 2 = Ende
	char mtext[100];
} msg;

int main(void){
	int msqid, msqflag, len, flag, rc;
	key_t msqkey;
	len = sizeof(msg.maction); // zu sendende Nachrichtenbytes
	flag = 0; // sende blockierend, wenn Queue voll
	
	msqflag = IPC_CREAT | 0644; // nur Eigentuemer soll schreiben knnen, die anderen lesen
	msqkey = 251; // eindeutiger Key

	if((msqid = msgget(msqkey, msqflag)) < 0){
		perror("Fehler beim Erzeugen der Message Queue");
		return 1;
	}
	
	msg.mtyp = getpid(); // Prozess-ID als Nachrichten-Kennzeichen verwenden
	
	// Empfaenger-Prozess ueber neuen Sender informieren
	msg.maction = 0;
	if((rc=msgsnd(msqid, &msg, len, flag)) < 0){
		perror("Fehler beim Senden der Initial-Nachricht.");
		return 2;
	}
	
	// Zeilen von stdin lesen und an Message Queue senden bis EOF
	msg.maction = 1;
	printf("Text eingeben\n");
	printf(": ");
	while((fgets(msg.mtext, sizeof(msg.mtext), stdin)) != NULL){
		len = strlen(msg.mtext)+1 + sizeof(msg.maction); // zu sendende Nachrichtenbytes
		if((rc=msgsnd(msqid, &msg, len, flag)) < 0){
			perror("Fehler beim Senden der Nachricht.");
			return 3;
		}
		printf(": ");
	}
	
	// Empfaenger-Prozess ueber Sender-Ende informieren
	msg.maction = 2;
	if((rc=msgsnd(msqid, &msg, len, flag)) < 0){
		perror("Fehler beim Senden der Abmelde-Nachricht.");
		return 4;
	}

	return 0;
}
